# ULTIMATE TRIMMER

Youtube の動画コメントで指定された時間を CSV ファイルに保存し、指定された部分をトリミングするスクリプトです。

# インストール

```
$ pip install ultimate-trimmer
```

# 使い方

## １．動画コメントの取得

- Youtube のコメントを取得する場合は、youtube の動画 URL を引数に指定してください。

```
$ ultcom https://www.youtube.com/watch?v=...
API KEY >{ここにGoogle CloudのAPIキーを入力}
```

- API キーは初回のみ入力が必要です。（設定ファイルは`~/.ultrimrc`に保存されます。API キーを再設定する場合は直接編集してください。）

## ２．出力されたコメントファイルを編集

- 出力されたコメントファイルを開いて動画ファイル名の項目と動画 ID の項目を設定してください。
  - 動画ファイル名: トリミングを行う動画のファイル名を相対パスで指定してください。
  - 動画 ID: トリミング後のファイル名の先頭に付ける文字列を指定してください。デフォルトで Youtube の動画 ID が指定されています。

## ３．動画のトリミング

- 以下のコマンドを実行してください

```
$ ultrim csvfile1.csv csvfile2.csv ...
```

- 実行後、`trim` フォルダに切り抜き動画が保存されます。

# CSV ファイルのフォーマット

- このフォーマットは`ultcom`コマンドを実行すると自動で生成されます。

|     動画ファイル名     |     動画 ID     |           |                                    |
| :--------------------: | :-------------: | :-------: | :--------------------------------: |
| {ここに動画ファイル名} | {ここに動画 ID} |           |                                    |
|                        |                 |           |                                    |
|          開始          |      終了       |   属性    |                感想                |
|          0:12          |      0:30       | free miss | よくできましたとしか言いようがない |
|        1:02:05         |     1:02:20     |    run    |           すげえ良い感じ           |

# `ultcom`コマンドのオプション

## `--save`：保存ファイル名を変更

- `--save`オプションで保存するファイル名を変更できます。
  - デフォルト値：`comments.csv`
  - 例：`savedir/game1_comments.csv`に保存

```
$ ultcom https://www.youtube.com/watch?v=... --save savedir/game1_comments.csv
```

# `ultrim`コマンドのオプション

## `--save`：保存ディレクトリを変更

- `--save`オプションでクリップを保存するディレクトリを指定出来ます。
  - デフォルト値：`trim/`
  - 例：`savedir/`に保存

```
$ ultrim csvfile.csv --save savedir/
```

## `--expand`：クリップの領域を拡張

- `--expand`オプションでクリップの秒数を前後に拡張できます。
  - デフォルト値：`3 3`
  - 例：前を 5 秒，後ろを 3 秒拡張する場合

```
$ ultrim csvfile.csv --expand 5 3
```

- この例では，0:10-1:59 のクリップは 0:05-2:02 に拡張されて切り抜かれます。

## `--altnum`：タイトルを代用する際のオプション

- `--save`オプションでファイル名に入れる感想の先頭文字数を指定出来ます。
  - デフォルト値：`10`
  - 例：先頭文字数を 5 文字とする場合

```
$ ultrim csvfile.csv --altnum 5
```

- この例では，感想が「よくできましたとしか言いようがない」の場合，タイトルは「よくできま」になります。

# 動作環境

Windows ＋ python 環境での動作を想定しています。
